<?php

class eMJP_playlist_downloads 
{
	var $version = '1.0';
	var $ops = false;
	var $dbug = '';
	var $ID = 0;

	
	//~~
	function __construct ()
	{
		$this->ops = $this->checkCompat();
	}

	
	//~~
	function hookup ()
	{
		if ( function_exists('mp3j_put') ) {
			if ( is_admin() ) {
				global $MP3JP;
				$version = substr( $MP3JP->version_of_plugin, 0, 3 );
				if ( $version > 2.6 ) {
					add_action('MJPsettings_downloads_above', array( $this, 'drawSettingsContainer' ), 10 );
				} else {
					add_action('MJPsettings_playlist', array( $this, 'drawSettingsContainer' ), 10 );
				}
				add_action('MJPsettings_submit', array( $this, 'settingsSubmit' ), 10 );
			} else {
				add_action('wp_footer', array( $this, 'frontendEnqueue' ), 1 );
				add_action('wp_footer', array( $this, 'frontendInline' ), 190 ); //late but before mp3 jplayer inline (200)
			}
		}
	}
	
	
	//~~
	function checkCompat ()
	{
		$this->dbug .= '#checkCompat.';
		$ops = get_option( MP3Jpd_SETTINGS_NAME );
		if ( empty( $ops ) ) {
			$ops = $this->defaults();
			update_option( MP3Jpd_SETTINGS_NAME, $ops );
		}
		else {
			if ( $ops['version'] !== $this->version ) {
				$ops = $this->update( $ops );
			}
		}
		return $ops;
	}

	
	//~~
	function update ( $old )
	{
		$this->dbug .= '#update.';
		$ops = $this->defaults();
		foreach ( $ops as $k => $op ) {
			if ( array_key_exists( $k, $old ) ) {
				$ops[$k] = $old[$k];
			}
		}
		$ops['version'] = $this->version; //set last!
		update_option( MP3Jpd_SETTINGS_NAME, $ops );
		return $ops;
	}
	
	
	//~~
	function defaults ()
	{
		$defaults = array(
			'listButtons'			=> 'true',
			'defaultButton'			=> 'true',
			'cssOn'		 			=> 'true',
			'coloursOn'		 		=> 'true',
			'listButtonText'		=> 'Download',
			'listButtonPosition'	=> 'right',
			'listButtonTextcolour' 	=> '#ffffff',
			'listButtonBGcolour' 	=> '#00b8c4',
			'listButtonFontSize'	=> '12px',
			'listButtonTopMargin'	=> '10px',
			'listButtonRightMargin'	=> '10px',
			'listButtonBottomMargin'=> '10px',
			'listButtonLeftMargin'	=> '10px',
			
			'version'				=> $this->version,
		);
		return $defaults;
	}
	
	
	//~~
	function settingsSubmit () 
	{	
		$this->ops['cssOn'] 	= ( isset( $_POST['zpl_cssOn'] ) ) 				? 'true' : 'false';
		$this->ops['coloursOn'] = ( isset( $_POST['zpl_coloursOn'] ) ) 			? 'true' : 'false';
		$this->ops['listButtons'] 	= $this->cleanValue( $_POST['zpl_listButtons'] );
		$this->ops['defaultButton'] = ( isset( $_POST['zpl_defaultButton'] ) ) 	? 'false' : 'true';
		
		$this->ops['listButtonText'] 		= $this->cleanValue( $_POST['zpl_listButtonText'] );
		$this->ops['listButtonPosition'] 	= $this->cleanValue( $_POST['zpl_listButtonPosition'] );
		$this->ops['listButtonTextcolour'] 	= $this->cleanValue( $_POST['zpl_listButtonTextcolour'] );
		$this->ops['listButtonBGcolour'] 	= $this->cleanValue( $_POST['zpl_listButtonBGcolour'] );
		$this->ops['listButtonFontSize'] 	= $this->cleanValue( $_POST['zpl_listButtonFontSize'] );
		$this->ops['listButtonTopMargin'] 		= $this->cleanValue( $_POST['zpl_listButtonTopMargin'] );
		$this->ops['listButtonRightMargin'] 	= $this->cleanValue( $_POST['zpl_listButtonRightMargin'] );
		$this->ops['listButtonBottomMargin'] 	= $this->cleanValue( $_POST['zpl_listButtonBottomMargin'] );
		$this->ops['listButtonLeftMargin'] 		= $this->cleanValue( $_POST['zpl_listButtonLeftMargin'] );
		
		$this->ops['version'] = $this->version;
		update_option( MP3Jpd_SETTINGS_NAME, $this->ops );
	}
	
	
	//~~
	function drawSettingsContainer ()
	{
	?>
		<div class="mjpmodule">
			
			<div style="border-bottom:1px solid #f0f0f0; background:#fff; padding:12px 10px 6px 10px;margin-bottom:10px;">
				<table class="player-settings" style="margin:0; padding:0; width:100%;">
					<tr>
						<td><p class="" style="margin:0; min-height:25px; padding-left:18px; background: url('<?php echo MP3Jpd_PLUGIN_URL. '/css/images/download-icon.png'; ?>') no-repeat left 6px;"><span class="" style="font-size:15px; padding-left:0px; color:#505050; font-weight:600;">Playlist Downloads</span></p></td>
						<td>
							<p class="r" style="margin:0; min-height:25px;">
								<span class="description" style="font-size:14px;">&nbsp;</span><span class="description">Use module's CSS</span>&nbsp;&nbsp;<input type="checkbox" name="zpl_cssOn" id="zpl_cssOn" value="true" <?php if ( $this->ops['cssOn'] == "true" ) { echo 'checked="checked"'; }?> />
								&nbsp;&nbsp;<span class="description">Use Colours</span>&nbsp;&nbsp;<input type="checkbox" name="zpl_coloursOn" id="zpl_coloursOn" value="true" <?php if ($this->ops['coloursOn'] == "true") { echo 'checked="checked"'; }?> />
							</p>
						</td>
					</tr>
				</table>
			</div>
			
			<div style="padding:5px 15px 15px 15px;">				
				<table class="playlistDownloadsTable">
					<tr>
						<td style="width:30%;"><label for="zpl_listButtons"><strong>Add Download Buttons in Playlists</strong></label></td>
						<td>
							<select name="zpl_listButtons" id="zpl_listButtons" style="width:70px;">
								<option value="true"<?php if ( $this->ops['listButtons'] == "true" ) { echo ' selected="selected"'; } ?>>Yes</option>
								<option value="false"<?php if ( $this->ops['listButtons'] == "false" ) { echo ' selected="selected"'; } ?>>No</option>
							</select>
						</td>
					</tr>
					<tr>
						<td>&nbsp;Button Text:</td>
						<td><input style="width:180px;" type="text" value="<?php echo $this->ops['listButtonText']; ?>" name="zpl_listButtonText" id="zpl_listButtonText" style="width:140px;" /></td>
					</tr>
					<tr>
						<td>&nbsp;Button Position:</td>
						<td><select name="zpl_listButtonPosition" id="zpl_listButtonPosition" style="width:70px;">
								<option value="left"<?php if ( $this->ops['listButtonPosition'] == "left" ) { echo ' selected="selected"'; } ?>>Left</option>
								<option value="right"<?php if ( $this->ops['listButtonPosition'] == "right" ) { echo ' selected="selected"'; } ?>>Right</option>
							</select></td>
					</tr>
					<tr>
						<td>&nbsp;Text Colour:</td>
						<td><input type="text" value="<?php echo $this->ops['listButtonTextcolour']; ?>" name="zpl_listButtonTextcolour" id="zpl_listButtonTextcolour" /></td>
					</tr>
					<tr>
						<td>&nbsp;BG colour:</td>
						<td><input type="text" value="<?php echo $this->ops['listButtonBGcolour']; ?>" name="zpl_listButtonBGcolour" id="zpl_listButtonBGcolour" /></td>
					</tr>
					<tr>
						<td>&nbsp;Font Size:</td>
						<td><input type="text" style="width:70px;" value="<?php echo $this->ops['listButtonFontSize']; ?>" name="zpl_listButtonFontSize" id="zpl_listButtonFontSize" /></td>
					</tr>
					<tr>
						<td>&nbsp;Margins:</td>
						<td>
							Left: <input type="text" style="width:50px;" value="<?php echo $this->ops['listButtonLeftMargin']; ?>" name="zpl_listButtonLeftMargin" id="zpl_listButtonLeftMargin" />
							&nbsp; &nbsp; Right: <input type="text" style="width:50px;" value="<?php echo $this->ops['listButtonRightMargin']; ?>" name="zpl_listButtonRightMargin" id="zpl_listButtonRightMargin" />
							&nbsp; &nbsp; Top: <input type="text" style="width:50px;" value="<?php echo $this->ops['listButtonTopMargin']; ?>" name="zpl_listButtonTopMargin" id="zpl_listButtonTopMargin" />
							&nbsp; &nbsp; Bottom: <input type="text" style="width:50px;" value="<?php echo $this->ops['listButtonBottomMargin']; ?>" name="zpl_listButtonBottomMargin" id="zpl_listButtonBottomMargin" />
						</td>
					</tr>
					<tr>
						<td>&nbsp;<label for="zpl_defaultButton" style="font-weight:normal;">Hide the Default Download Button:</label></td>
						<td><input type="checkbox" name="zpl_defaultButton" id="zpl_defaultButton" value="false" <?php if ( $this->ops['defaultButton'] == 'false' ) { echo ' CHECKED'; } ?>/></td>
					</tr>
				</table>				
			</div>
			
			<input type="hidden" name="zpl_version" value="<?php echo $this->version; ?>" />
		</div>
		
		<script>
		jQuery( document ).ready( function () {
			MP3jP.initSpectrumPicker( 'zpl_listButtonTextcolour', {
				clickoutFiresChange:	true,
				move: function( color ) {
					jQuery('#zpl_listButtonTextcolour').val( color );
				},
				preferredFormat: 		'hex',
				showInput:				true,
				showAlpha: 				false
			});
			MP3jP.initSpectrumPicker( 'zpl_listButtonBGcolour', {
				clickoutFiresChange:	true,
				move: function( color ) {
					jQuery('#zpl_listButtonBGcolour').val( color );
				},
				preferredFormat: 		'hex',
				showInput:				true,
				showAlpha: 				false,
				allowEmpty:				true
			});
		});
		</script>
		
		<style>
		.mjpmodule {
			border:			1px solid #e7e7e7; 
			background:		#fcfcfc; 
			width:			100%; 
			border-radius:	3px; 
			margin:			15px 0 0 0; 
			max-width:		878px;
		}
		
		.mjpmodule hr {
			border-top:	1px solid #e7e7e7;
			border-bottom: 1px solid #fff;
		}
		
		.playlistDownloadsTable {
			width:100%;
		}
		
		.playlistDownloadsTable td {
			padding:	0 0 10px 0 !important;
		}
		</style>
		
	<?php
	}
	

	//~~
	function frontendEnqueue ()
	{
		global $MP3JP;
		if ( $MP3JP->Player_ID > 0 ) {
			if ( 'true' === $this->ops['cssOn'] ) {
				wp_enqueue_style( 'zipped-playlists', plugins_url( '/css/frontend.css', __FILE__ ) );
			}
			wp_enqueue_script( 'zipped-playlists-js', plugins_url( '/js/frontend.js', __FILE__ ), array( 'jquery' ) );
		}
	}
	
	
	//~~
	function frontendInline ()
	{
		global $MP3JP;
		if ( $MP3JP->Player_ID > 0 ) {	
		?>
<script>
jQuery( document ).ready( function () {
	if ( typeof MP3_JPLAYER !== 'undefined' ) {
		if ( typeof MP3J_pd !== 'undefined' ) {
			MP3J_pd.settings = {
				lButtons: <?php echo $this->ops['listButtons']; ?>,
				dButtons: <?php echo $this->ops['defaultButton']; ?>,
				lText: '<?php echo $this->ops['listButtonText']; ?>',
				lClass: 'pd_<?php echo $this->ops['listButtonPosition']; ?>',
			};
			MP3J_pd.plugin_url = '<?php echo MP3Jpd_PLUGIN_URL; ?>';
			MP3J_pd.init();
		}
	}
});
</script>

			<?php
			$tm = $this->ops['listButtonTopMargin'] ? $this->ops['listButtonTopMargin'] : '0';
			$rm = $this->ops['listButtonRightMargin'] ? $this->ops['listButtonRightMargin'] : '0';
			$bm = $this->ops['listButtonBottomMargin'] ? $this->ops['listButtonBottomMargin'] : '0';
			$lm = $this->ops['listButtonLeftMargin'] ? $this->ops['listButtonLeftMargin'] : '0';
			
			$CSS = "";
			if ( $this->ops['coloursOn'] === 'true' ) 
			{
				$CSS .= "\n<style>\n";
				$CSS .= ".pd_listButtonWrap { padding:" . $tm . " " . $rm . " " . $bm . " " . $lm . "; }\n";
				$CSS .= ".pd_listButtonWrap a, .pd_listButtonWrap a:hover { background-color:" . ( $this->ops['listButtonBGcolour'] ? $this->ops['listButtonBGcolour'] : 'transparent' ) . "; color:" . $this->ops['listButtonTextcolour'] . "; font-size:" . $this->ops['listButtonFontSize'] . "; }\n";
				
				$version = substr( $MP3JP->version_of_plugin, 0, 3 );
				if ( $version < 2.7 ) {
					$CSS .= " .li-mjp { clear: both; }\n";
				}
				$CSS .= "\n</style>\n";
			}
			echo $CSS;
		}
	}
	
	
	//~~
	function cleanValue ( $value )
	{
		$search = array(
			'@<script[^>]*?>.*?</script>@si', 	// Strip out javascript 
			'@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly 
			'@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments including CDATA 
		);
		$text = preg_replace( $search, '', $value ); 
		return $text;
	}
	
	
	//~~
	function prepPath ( $field )
	{
		$search = array( "'", '"', ';', '\\' );
		$option = str_replace( $search, "", $field );
		$option = strip_tags( $option );
		
		if (preg_match("!^/!", $option) == 0) { //no starting slash then add one
			$option = "/" . $option; 
		} else { 
			$option = preg_replace("!^/+!", "/", $option); //or just make sure theres only one
		} 
		
		if (preg_match("!.+/+$!", $option) == 1) { //remove any ending slashes
			$option = preg_replace("!/+$!", "", $option); 
		}
		
		return $option;
	}

} //close class
?>